#ifdef __EMX__
	#include <stdlib.h>
#endif
#ifndef WIN32
	#include <sys/time.h>
	#include <unistd.h>
#else
	#include <time.h>
#endif
#include <string.h>

#include "cfg.h"

/* gets current time in microseconds */
unsigned long_long get_time(void)
{
#ifndef WIN32
	struct timeval tv;
	struct timezone tz;

	memset(&tz,0,sizeof(tz));
	gettimeofday(&tv,&tz);
	return ((unsigned long_long)tv.tv_sec)*1000000+(unsigned long_long)tv.tv_usec;
#else
	return ((unsigned long_long)GetTickCount())*1000UL;
#endif
}


/* waits until time t passes */
void sleep_until(unsigned long_long t)
{
	unsigned long_long u=get_time();


	if (u>=t) return;
	t-=u;
#if defined(WIN32)
	Sleep(t/1000);
#elif defined(__EMX__)
	_sleep2(t/1000);
#else
	usleep(t);
#endif
}

